commit 9075f62ddc3b9ffdb9e1b28d472adfd7fef4a0f1
Author: Iain Buclaw <ibuclaw@gdcproject.org>
Date:   Mon Jul 26 15:24:12 2021

    d: __FUNCTION__ doesn't work in core.stdc.stdio functions without cast (PR101441)
    
    Backports fix from upstream to allow __FUNCTION__ and
    __PRETTY_FUNCTION__ to be used as C string literals.
    
    Reviewed-on: https://github.com/dlang/dmd/pull/12923
    
            PR d/101441
    
    gcc/d/ChangeLog:
    
            * dmd/expression.c (FuncInitExp::resolveLoc): Set type as `string'.
            (PrettyFuncInitExp::resolveLoc): Likewise.
    
    gcc/testsuite/ChangeLog:
    
            * gdc.test/compilable/b19002.d: New test.
    
    (cherry picked from commit 1a2306ffe79df89389cc850ce85c586d0f1c8264)

diff --git a/gcc/d/dmd/expression.c b/gcc/d/dmd/expression.c
index 7166f972424..18aa6aa9ab4 100644
--- a/gcc/d/dmd/expression.c
+++ b/gcc/d/dmd/expression.c
@@ -5620,7 +5620,7 @@ Expression *FuncInitExp::resolveLoc(Loc loc, Scope *sc)
         s = "";
     Expression *e = new StringExp(loc, const_cast<char *>(s));
     e = expressionSemantic(e, sc);
-    e = e->castTo(sc, type);
+    e->type = Type::tstring;
     return e;
 }
 
@@ -5654,7 +5654,7 @@ Expression *PrettyFuncInitExp::resolveLoc(Loc loc, Scope *sc)
 
     Expression *e = new StringExp(loc, const_cast<char *>(s));
     e = expressionSemantic(e, sc);
-    e = e->castTo(sc, type);
+    e->type = Type::tstring;
     return e;
 }
 
diff --git a/gcc/testsuite/gdc.test/compilable/b19002.d b/gcc/testsuite/gdc.test/compilable/b19002.d
new file mode 100644
index 00000000000..fd8e6d18b37
--- /dev/null
+++ b/gcc/testsuite/gdc.test/compilable/b19002.d
@@ -0,0 +1,12 @@
+module b19002;
+
+void printf(scope const char* format){}
+
+void main()
+{
+    printf(__FILE__);
+    printf(__FILE_FULL_PATH__);
+    printf(__FUNCTION__);
+    printf(__PRETTY_FUNCTION__);
+    printf(__MODULE__);
+}

